class reflector:
  def __init__(self,L):
    self.L = L
  def op(self,c):
    return self.L[c]

class rotor:
  i = 0
  def __init__(self,L):
    self.L = L
  def set_pos(self,i):
    self.i = i
  def step(self):
    self.i = self.i + 1
    if(self.i==10):
      self.i = 0
      return True
    else:
      return False
  def rl(self,c):
    for j in range(10):
      if(self.L[(j+self.i)%10]==((c+self.i)%10)):
        return j
  def lr(self,c):
    return (self.L[(c+self.i)%10]-self.i)%10
  def p(self):
    print self.L

class machine:
  def __init__(self,order,key,plugs):
    self.R = reflector([7, 6, 9, 8, 5, 4, 1, 0, 3, 2])
    self.A = rotor([9, 8, 7, 5, 0, 4, 3, 1, 6, 2])
    self.B = rotor([2, 4, 8, 0, 9, 1, 5, 3, 6, 7])
    self.C = rotor([9, 5, 8, 0, 1, 2, 7, 6, 4, 3])
    self.L = []
    self.order = order
    for j in range(3):
      self.L.append([self.A,self.B,self.C][order[j]])    
    self.plugs = plugs
    self.set_key(key)
  def set_key(self,pos):
    self.L[0].set_pos(pos[2])
    self.L[1].set_pos(pos[1])
    self.L[2].set_pos(pos[0])
  def p(self):
    print "machine({0},[{1}, {2}, {3}],{4})".format(self.order,self.L[2].i,self.L[1].i,self.L[0].i,self.plugs)
  def step(self,n=1):
    for j in range(n):
      if(self.L[0].step()):
        if(self.L[1].step()):
          self.L[2].step()
  def f(self,c):
    for plug in self.plugs:
      if(c==plug[0]):
        c = plug[1]
      elif(c==plug[1]):
        c = plug[0]
    for j in range(3):
       c = self.L[j].rl(c)
    c = self.R.op(c)
    for j in range(3):
       c = self.L[2-j].lr(c)
    self.step()
    for plug in self.plugs:
      if(c==plug[0]):
        c = plug[1]
      elif(c==plug[1]):
        c = plug[0]
    return c
  def cypher(self,chain):
    cyphertext = []
    p0 = chain[0]
    p1 = chain[1]
    p2 = chain[2]
    for j in range(6):
      cyphertext.append(self.f(chain[j]))
    self.set_key([p0,p1,p2])
    for j in range(6,len(chain)):
      cyphertext.append(self.f(chain[j]))
    return cyphertext
  def uncypher(self,chain):
    plaintext = []
    for j in range(6):
      plaintext.append(self.f(chain[j]))
    p0 = plaintext[0]
    p1 = plaintext[1]
    p2 = plaintext[2]
    if(plaintext[3]!=p0 or plaintext[4]!=p1 or plaintext[5]!=p2):
      plaintext.append(-1)
    else:
      self.set_key([p0,p1,p2])
      for j in range(6,len(chain)):
        plaintext.append(self.f(chain[j]))
    return plaintext


mensaje = [1, 8, 5, 5, 8, 4, 8, 9, 3, 5, 5, 8, 1, 1, 0, 5, 9, 8, 0, 6, 2, 1, 7, 1, 0, 0]
E = machine([1, 0, 2],[3, 7, 8],[[0,1]])
print E.uncypher(mensaje)

for i in range(10):
  for j in range(10):
    if(i<j):
      E = machine([1, 0, 2],[3, 7, 8],[[i,j]])
      des = E.uncypher(mensaje)
      if(des[6]!=-1):
        print [i,j],des

